return require('packer').startup(function(use)
    -- language server
    use {
        'junnplus/nvim-lsp-setup',
        requires = {
            'neovim/nvim-lspconfig',
            'williamboman/nvim-lsp-installer',

            -- additional rust tools
            "simrat39/rust-tools.nvim",

            -- highlight current symbol
            "RRethy/vim-illuminate",

            -- lua plugin development
            "folke/lua-dev.nvim",

            -- lsp status
            "nvim-lua/lsp-status.nvim",
        },
        config = function() require('plugins.nvim-lsp-setup') end,
    }

    -- null-ls
    use {
        "jose-elias-alvarez/null-ls.nvim",
        config = function()
            require("null-ls").setup({
                sources = {
                    require("null-ls").builtins.formatting.prettier,
                },
                on_attach = function(client)
                    local utils = require("nvim-lsp-setup.utils")
                    utils.format_on_save(client)
                end,
            })
        end,
    }
end)
